package visorComics;

import java.awt.BorderLayout;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.File;
import java.util.ArrayList;

import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;


public class VisorUI implements ActionListener, MouseListener, ListSelectionListener {

	private JFrame frame;
	private JPanel panelListado;
	private JList<ImageIcon> listaImagenesMiniatura;
	DefaultListModel<ImageIcon> modelo;
	private JScrollPane scrollImagen;
	private JLabel lienzo;
	private JMenuBar barraMenu;
	private JMenu menuAbrir;
	private JMenuItem itemArchivo;
	private JFileChooser chooser = new JFileChooser();
	private Thread hilo;
	private ArrayList<File> listadoDirectorio;
	private boolean estadoPantallaCompleta = false;
	private static GraphicsDevice grafica = GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice();
	private int indice = -1;
	
	public VisorUI() {
		//Crear frame
		frame = new JFrame("Visor de Imagenes: Comico!");
		frame.getContentPane().setLayout(new BorderLayout());
		
		//Crear componentes		
		barraMenu = new JMenuBar();
		menuAbrir = new JMenu("Archivo");
		barraMenu.add(menuAbrir);
		itemArchivo = new JMenuItem("Abrir directorio con imagenes");
		menuAbrir.add(itemArchivo);
		
		//Crear panel
		panelListado = new JPanel();
		panelListado.setLayout(new BorderLayout());
		
		//Creando el JList y estableciendo propiedades
		listaImagenesMiniatura = new JList<ImageIcon>();
		modelo = new DefaultListModel<ImageIcon>();
		//Caractetisticas del JList
		listaImagenesMiniatura.setModel(modelo);
		listaImagenesMiniatura.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		listaImagenesMiniatura.setDoubleBuffered(true);
		listaImagenesMiniatura.setFixedCellHeight(155);
		listaImagenesMiniatura.setFixedCellWidth(105);
		//Agrego la lista a un JScrollPane
		JScrollPane listaScroll = new JScrollPane(listaImagenesMiniatura);
		listaScroll.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		
		//Creo el lienzo(JLabel) que contendra las imagenes
		lienzo = new JLabel();
		lienzo.setHorizontalAlignment(SwingConstants.CENTER);		
		scrollImagen = new JScrollPane(lienzo);
		scrollImagen.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		scrollImagen.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		
		//Agregar componentes a los paneles		
		panelListado.add(listaScroll, BorderLayout.CENTER);
		
		//Agregar al frame
		frame.add(scrollImagen, BorderLayout.CENTER);
		frame.add(panelListado, BorderLayout.WEST);
		frame.add(barraMenu, BorderLayout.NORTH);
		
		//Caracteristicas del frame
		frame.setVisible(true);
		frame.setSize(600, 850);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		//Listener para los componentes		
		itemArchivo.addActionListener(this);
		listaImagenesMiniatura.addListSelectionListener(this);
		lienzo.addMouseListener(this);		
	}
/**
 * 
 */
	public void valueChanged(ListSelectionEvent arg0) {
		JScrollBar verticalScrollBar = scrollImagen.getVerticalScrollBar();
	    JScrollBar horizontalScrollBar = scrollImagen.getHorizontalScrollBar();
	    
	    verticalScrollBar.setValue(verticalScrollBar.getMinimum());
	    horizontalScrollBar.setValue(horizontalScrollBar.getMinimum());
	    
		indice = listaImagenesMiniatura.getSelectedIndex();	    
	    lienzo.setIcon(new ImageIcon(listadoDirectorio.get(indice).toString()));
	    
	    frame.setTitle(listadoDirectorio.get(indice).toString());
	    lienzo.repaint();	
	}
/**
 * 
 */
	public void mouseClicked(MouseEvent evento) {
		if(listadoDirectorio != null) {
			if(evento.isMetaDown()) {
				if(indice > 0) {
					JScrollBar verticalScrollBar = scrollImagen.getVerticalScrollBar();
				    JScrollBar horizontalScrollBar = scrollImagen.getHorizontalScrollBar();
				    
				    verticalScrollBar.setValue(verticalScrollBar.getMinimum());
				    horizontalScrollBar.setValue(horizontalScrollBar.getMinimum());
				    
					indice--;
					lienzo.setIcon(new ImageIcon(listadoDirectorio.get(indice).toString()));
					
					frame.setTitle(listadoDirectorio.get(indice).toString());
					lienzo.repaint();
				}
			}
			else if(evento.isAltDown()) {
				if(!estadoPantallaCompleta) {
					barraMenu.setVisible(false);
					panelListado.setVisible(false);
					
					grafica.setFullScreenWindow(frame);
					frame.validate();
				} else {
					barraMenu.setVisible(true);
					panelListado.setVisible(true);
					grafica.setFullScreenWindow(null);
				}
				estadoPantallaCompleta = !estadoPantallaCompleta;
			}
			else {
				if(indice < listadoDirectorio.size()-1) {
					JScrollBar verticalScrollBar = scrollImagen.getVerticalScrollBar();
				    JScrollBar horizontalScrollBar = scrollImagen.getHorizontalScrollBar();
				    
				    verticalScrollBar.setValue(verticalScrollBar.getMinimum());
				    horizontalScrollBar.setValue(horizontalScrollBar.getMinimum());
				    
					indice++;
					lienzo.setIcon(new ImageIcon(listadoDirectorio.get(indice).toString()));
					
					frame.setTitle(listadoDirectorio.get(indice).toString());
					lienzo.repaint();
				}
			}
		}
	}
	public void mouseEntered(MouseEvent arg0) {	
	}
	public void mouseExited(MouseEvent arg0) {
	}
	public void mousePressed(MouseEvent arg0) {
	}
	public void mouseReleased(MouseEvent arg0) {	
	}
/**
 * 
 */
	public void actionPerformed(ActionEvent arg0) {
		if(arg0.getSource().equals(itemArchivo)) {
			chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			int valor = chooser.showOpenDialog(frame);
			if(valor == JFileChooser.APPROVE_OPTION) {
				File file = chooser.getSelectedFile();
				if(file.isDirectory()) {
					listadoDirectorio = new ArrayList<File>();
					File [] contenido = file.listFiles(new FiltroExtensionArchivo());
					for(File archivo : contenido) {
						listadoDirectorio.add(archivo);
					}
					CrearMiniaturas miniaturas = new  CrearMiniaturas(listadoDirectorio, listaImagenesMiniatura);
					hilo = new Thread(miniaturas);
					hilo.start();
				}
			}
		}
	}
}
